--[[
# -*- coding: utf-8 -*-
This ^ thing is for saving this file with UTF-8 encoding. The block comments are here to make sure
it won't interfere with the game.]]

--Grabs all of the .lua files code for use
require "fileloader"
require "player"
require "enemy"
require "cointable"
require "powertable"
require "powerinfos"
require "menu"
require "saving"

function love.load()
--Sets the background color to black and loads all files/vars on launch
	love.graphics.setBackgroundColor(0,0,0)
	fileloader()
	load()
--Powerup stuff
	power_drop_time = 0 --Time that another powerup will drop
	power_last_time = 15 --How long powerup lasts
	power_reset_time = 0 --Time when power is taken away
--
--Defining window size for ease of use within main.lua code
	gwidth = love.window.getWidth()
	gheight = love.window.getHeight()
--
--Enemy speed notification vars
	textSpeed = 25
	showText = 0
	enemySpeedAlpha = 255
	enemySpeedTextX = 10
--
--Just game vars
	theme = 0
	gamemode = 0
	keyboard = 1
	mouseHeld = love.mouse.isGrabbed()
	gamestate = "menu"
	paused = false
	gravity = 1800
	groundFloor = 636
	v_volume = 0.40
	v_change_amount = 0.10
	love.audio.setVolume(v_volume)
	coin_amount = 0
	enemy_amount = 0
	power_amount = 0
	highscores = {highscore1, highscore2, highscore3}
	newScore = 0
--
--Button spawning code **See menu.lua for complete function
	b_spawned_about = false
	b_spawned_set = false
	b_spawned_lost = false
	b_spawned_scores = false
	b_spawned_controls = false
	b_spawned_pause = false
--
--Spawns buttons main menu buttons **See menu.lua for more button spawning
	button_spawn(gwidth/2-156,gheight/2-158,"play",play_button_img)
	button_spawn(gwidth/2-156,gheight/2,"settings",settings_button_img)
	button_spawn(gwidth/2-156,gheight/2+158,"quit",quit_button_img)
	button_spawn(gwidth-168,gheight-88,"scorelist",score_button_img)
	button_spawn(gwidth-168,gheight-168,"about",about_button_img)
--
end

function love.draw()
		love.graphics.setColor(255,255,255)
		backgroundcheck()
		love.graphics.setFont(ParagraphFont)
		button_draw()

if gamestate == "playing" then
	player.Draw()
	
	coin.Draw()

	enemy.Draw()

	power.Draw()
	power_img_draw()
		love.graphics.setColor(255,255,255,100)
	love.graphics.rectangle("fill",5,5,350,150)--Actual menu
		love.graphics.setColor(0,0,0,255)
	love.graphics.rectangle("line",5,5,350,150)--Outline of menu
		love.graphics.setColor(0,0,0)
	love.graphics.print(math.floor(power_drop_timeleft).. " until next drop",10,6)
	if player.power > 0 then
		love.graphics.print(string.format("Power time left: %.2f", power_last_time),10,31)
	elseif player.power == 0 then
		love.graphics.print("Power time left: Power not in use",10,31)
	end
	love.graphics.print("Score: " ..player.score,10,75)
	if gamemode == 0 then
		love.graphics.print("Score for extra life: " ..20-player.invisscore,10,100)
	elseif gamemode == 1 then
		love.graphics.print("Score for extra life: " ..23-player.invisscore,10,100)
	end
	love.graphics.print("Lives: " ..player.lives,10,125)
	love.graphics.print(player.lastPowerup,500,500)
		love.graphics.setColor(255,255,255)
		
	if showText == 1 then
			love.graphics.setColor(255,255,255,enemySpeedAlpha)
		love.graphics.print("Enemy Speed + by: " .. enemy.speedIncrease,enemySpeedTextX,enemySpeedTextY)
	end
		
	if paused == true then
			love.graphics.setColor(255,255,255)
		love.graphics.draw(pausedoverlay_img,0,0)
	end
end
if gamestate == "menu" then
	title_draw()
end
if gamestate == "settingstate" then
	title_draw()
	--Text Coverings
		love.graphics.setColor(0,0,0,100)
	love.graphics.rectangle("fill",25,gheight/2-200,145,50)--Volume Controller Title
	love.graphics.rectangle("fill",100,gheight/2-150,275,35)--Volume Controller Info
	love.graphics.rectangle("fill",830,gheight/2-200,215,50)--Gamemode Title
	love.graphics.rectangle("fill",905,gheight/2-150,275,35)--Gamemode Info
	love.graphics.rectangle("fill",25,gheight/2+15,150,50)--Controls Title
	love.graphics.rectangle("fill",100,gheight/2+65,275,35)--Controls Info
		love.graphics.setFont(ParagraphFont)
		love.graphics.setColor(255,255,255)
	love.graphics.printf("Volume Control",30,gheight/2-200,gwidth,"left")--Volume Controller Title
	love.graphics.printf("GameMode Selector",835,gheight/2-200,gwidth,"left")--Gamemode Title
	love.graphics.printf("Control Scheme",30,gheight/2+15,gwidth,"left")--Controls Title
	love.graphics.printf("Current Volume Setting: " ..v_volume,110,gheight/2-150,gwidth,"left")--Volume Controller Info
	gameModeCheck_settings()--Gamemode Info
	controlCheck()--Controls Info
end
if gamestate == "lost" then
	title_draw()
		love.graphics.setColor(0,0,0,100)
	love.graphics.rectangle("fill",gwidth/2-288,gheight/2-75,575,100)
		love.graphics.setColor(255,255,255,255)
		love.graphics.setFont(SubTitleFont)
	love.graphics.printf("You were crushed, your score was: " .. player.score.. "\nWould you like to restart?",0,gheight/2-75,gwidth,"center")
	end
if gamestate == "localscores" then
	title_draw()
		love.graphics.setColor(0,0,0,100)
	love.graphics.rectangle("fill",gwidth/2-200,gheight/2-107.5,400,205)
		love.graphics.setColor(255,255,255)
	love.graphics.printf("Local High Score Table",0,gheight/2-100,gwidth,"center")
	for i = #highscores, 1, -1 do
		print(highscores[i])
	end
end
if gamestate == "controlstate" then
	title_draw()
		love.graphics.setColor(0,0,0,100)
	love.graphics.rectangle("fill",20,gheight/2-200,265,205)
	love.graphics.rectangle("fill",930,gheight/2-200,335,205)
		love.graphics.setColor(255,255,255,255)
		love.graphics.setFont(SubTitleFont)
	love.graphics.printf("Keyboard Controls",25,gheight/2-200,gwidth,"left")
	love.graphics.printf("AD: Move Player\nW: Jump\nSPACE: Pause Game",25,gheight/2-150,gwidth,"left")
	love.graphics.printf("Mouse Controls",-20,gheight/2-200,gwidth,"right")
	love.graphics.printf("Mouse: Move Player\nLeft Click: Jump\nRight Click: Pause Game",-20,gheight/2-150,gwidth,"right")
	end
if gamestate == "aboutstate" then
	title_draw()
		love.graphics.setColor(0,0,0,100)
	love.graphics.rectangle("fill",20,gheight/2-175,482,167)
	love.graphics.rectangle("fill",20,gheight/2+200,572,67)
		love.graphics.setColor(255,255,255,255)
		love.graphics.setFont(ParagraphFont)
	love.graphics.printf("Game Developed by: All0utWar\nDeveloped on the LÖVE2D Engine\nArt Created by: All0utWar\nSounds Created Using: Bfxr\nMusic Created by: [Awaiting Music]",25,gheight/2-175,gwidth,"left")
	love.graphics.printf("If you wish to contact me for any reason, you can go here:\nhttp://www.twitter.com/All0utWar",25,gheight/2+200,gwidth,"left")
	end
	button_draw()
end

function love.update(dt)
	button_IsSpawned()
if gamestate == "playing" and not paused then
	player.Move(dt)
	player.Checks(dt)
	mouseGrabber()
	getPowerup()

	coin.Move(dt)
	coin.Checks()
	sound_fix()

	enemy.Move(dt)
	enemy.Checks()
	enemySpeedNotif_Text()
	enemySpeedTimerUpdate(dt)

	power.Move(dt)
	power.Checks()
	power_drop_timeleft = power_drop_timeleft - (1 * dt)

	object_collect()
	object_spawner()
	powerupinfo()
	
	game_speed_timer = game_speed_timer + (1 * dt)
	
	if power_last_time < power_reset_time then
		player.power = 0
		power_last_time = 15
		end
	end
if gamestate == "settingstate" then
	number_check()
	end
end

function love.focus(f)
if gamestate == "playing" then
	if not f then
		paused = true
		end
	end
end

function love.keypressed(key)
	if key == "p" then
		delete()
	end
	if gamestate == "playing" then
		if keyboard == 1 then
			if key == " " and paused == true then
				paused = false
			elseif key == " " and paused == false then
				paused = true
			end
		end
	end
end

function love.keyreleased(key)
	if (key == "d") or (key == "a") then
		player.xVel = 0
	end
end

function love.mousepressed(x,y,button)
	if button == "l" then
		button_click(x,y)
	end
	if gamestate == "playing" then
		if keyboard == 0 then
			if button == "r" and paused == true then
				paused = false
			elseif button == "r" and paused == false then
				paused = true
			end
		end
	end
end

function object_collect()
	for i,v in ipairs(coin) do
	if CheckCollision(player.x,player.y,player.width,player.height, v.x,v.y,v.width,v.height) then
		love.audio.play(coin_snd)
		table.remove(coin,i)
		coin_amount = coin_amount - 1
		player.score = player.score + 1
		player.invisscore = player.invisscore + 1
	end
end
	for i,v in ipairs(power) do
	if CheckCollision(player.x,player.y,player.width,player.height, v.x,v.y,v.width,v.height) then
		love.audio.play(power_snd)
		table.remove(power,i)
		power_amount = power_amount -1
		power_last_time = 15
			if gamemode == 0 then
				player.power = math.random(1,4)
			elseif gamemode == 1 then
				player.power = math.random(1,3)
			end
		end
	end
end

function object_spawner()
	if gamestate == "playing" then
		if coin_amount < 2 then
			coin.Spawn(math.random(100,1180),math.random(-100,-800))
			coin_amount = coin_amount + 1
		end
		if enemy_amount < 3 then
			enemy.Spawn(math.random(0,1180),math.random(-200,-1500))
			enemy_amount = enemy_amount + 1
		end
		if power_amount < 1 and power_drop_timeleft < power_drop_time then
			power.Spawn(math.random(100,1180),math.random(-100,-500))
			power_drop_timeleft = 20
			power_amount = power_amount + 1
		end
	end
end

function backgroundcheck() --originally used with multiple background images, kept it this way and removed other options
		love.graphics.setColor(255,255,255)
	if theme == 0 then
		love.graphics.draw(default_img,0,0)
	end
end

function spritecheck()
		love.graphics.setColor(255,255,255)
	if gamemode == 0 then
		coin_img = coin_img_backup
		enemy_img = enemy_img_backup
	end
	if gamemode == 1 then
		coin_img = heart_img
		enemy_img = box_img
	end
end

function gameModeCheck_settings()
		love.graphics.setColor(255,255,255)
		love.graphics.printf("Check 'Gamemodes Help' if you're\nunfamiliar with the different modes.",905,gheight/2-85,gwidth,"left")
	if gamemode == 0 then
			love.graphics.setColor(255,255,255)
		love.graphics.printf("Default Mode Selected",940,gheight/2-150,gwidth,"left")
	end
	if gamemode == 1 then
			love.graphics.setColor(255,255,255)
		love.graphics.printf("Classic Mode Selected",945,gheight/2-150,gwidth,"left")
	end
end

function controlCheck()
		love.graphics.setColor(255,255,255)
	if keyboard == 1 then
		love.graphics.printf("Keyboard Selected",155,gheight/2+65,gwidth,"left")
	end
	if keyboard == 0 then
		love.graphics.printf("Mouse Selected",165,gheight/2+65,gwidth,"left")
		love.graphics.printf("Warning! With this option selected, highscores are disabled!",100,gheight/2+130,gwidth,"left")
	end
end

function game_Restart() --when play button is pressed, 'reset' game
	player.x = 50
	player.y = 0
	player.xVel = 0
	player.yVel = 0
	player.jumpVel = -800
	player.width = 80
	player.height = 80
	player.speed = 400
	player.lives = 3
	player.score = 0
	player.invisscore = 0
	player.state = "falling"
	player.power = 0
	player.power_name = "None"
	player.lastPowerup = 0
	power_last_time = 15
	power_drop_timeleft = 20
	game_speed_timer = 0
	enemy.speed = enemy.defaultSpeed
	enemy.newSpeed = enemy.defaultSpeed

	for i,v in ipairs(coin) do
		v.y = math.random(-100,-800)
	end
	for i,v in ipairs(enemy) do
		v.y = math.random(-200,-1000)
	end
	for i,v in ipairs(power) do
		v.y = math.random(-100,-600)
	end
end

function power_img_draw() --draws powerup overlays
	if player.power_name == "God" then
		love.graphics.draw(god_img,0,0)
	elseif player.power_name == "Speed" then
		love.graphics.draw(speed_img,0,0)
	elseif player.power_name == "Jump" then
		love.graphics.draw(jump_img,0,0)
	end
end

function addScore(highscores, newScore, n)
	local lowestScore = highscores[n]
	newScore = player.score
	if newScore > lowestScore then
		table.remove(highscores, n)
		table.insert(highscores, newScore)
		table.sort(highscores)
	end
end
	

function number_check() --ensures values don't exceed maximum amount
	if v_volume >= 1 then
		v_volume = 1
	elseif v_volume < 0.1 then
		v_volume = 0
	end
	if gamemode >=1 then
		gamemode = 1
	elseif gamemode <= 0 then
		gamemode = 0
	end
	if keyboard >= 1 then
		keyboard = 1
	elseif keyboard <= 0 then
		keyboard = 0
	end
end

function title_draw() --Easy and simple way of changing game title and version number
		love.graphics.setFont(TitleFont)
		love.graphics.setColor(255,255,255)
	love.graphics.printf("Collector",0,gheight/2-360,gwidth,"center")
		love.graphics.setFont(SubTitleFont)
	love.graphics.printf("Beta 6.1",0,gheight/2-240,gwidth,"center")
end

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
	return x1 < x2+w2 and
		x2 < x1+w1 and
		y1 < y2+h2 and
		y2 < y1+h1
end

function enemySpeedTimerUpdate(dt)
	if showText == 1 then
		enemySpeedAlpha = enemySpeedAlpha - 75 * dt
		enemySpeedTextY = enemySpeedTextY - textSpeed * dt
	end
	if enemySpeedAlpha <= 1 then
		enemySpeedAlpha = 0
	end
	
end

--[[This fix is a behemoth, and largely unnecessary.
Makes a clone of a sound if it's already playing and plays it
So that sounds don't cut off or not play a second time if needed to be
played one after another. Only works twice in a row though I believe.
That's all it should really need anyway.]]
function sound_fix()
	coin_snd2 = coin_snd:clone()
	coin_snd_isPlaying = coin_snd:isPlaying()
	if coin_snd_isPlaying then
		for i,v in ipairs(coin) do
			if CheckCollision(player.x,player.y,player.width,player.height, v.x,v.y,v.width,v.height) then
				coin_snd2:play()
			end
		end
	end
	hit_snd2 = hit_snd:clone()
	hit_snd_isPlaying = hit_snd:isPlaying()
	if hit_snd_isPlaying then
		for i,v in ipairs(enemy) do
			if CheckCollision(player.x,player.y,player.width,player.height, v.x,v.y,v.width,v.height) then
				hit_snd2:play()
			end
		end
	end
	god_hit_snd2 = god_hit_snd:clone()
	god_hit_snd_isPlaying = god_hit_snd:isPlaying()
	if god_hit_snd_isPlaying then
		for i,v in ipairs(enemy) do
			if CheckCollision(player.x,player.y,player.width,player.height, v.x,v.y,v.width,v.height) then
				god_hit_snd2:play()
			end
		end
	end
end