

button = {}

function button_spawn(x,y,id,image)
	table.insert(button, {x = x, y = y, id = id, image = image})
end

function button_IsSpawned()
if gamestate == "settingstate" then
	if b_spawned_set == false then
		button_spawn(12,630,"back",back_button_img)
		button_spawn(25,gheight/2-165,"v_left",leftarrow_button_img)
		button_spawn(375,gheight/2-165,"v_right",rightarrow_button_img)
		button_spawn(25,gheight/2+175,"controls",controls_button_img)
		button_spawn(830,gheight/2-165,"s_left",leftarrow_button_img)
		button_spawn(gwidth-100,gheight/2-165,"s_right",rightarrow_button_img)
		button_spawn(25,gheight/2+50,"km_left",leftarrow_button_img)
		button_spawn(375,gheight/2+50,"km_right",rightarrow_button_img)
		b_spawned_set = true
	end
elseif gamestate == "lost" then
	if b_spawned_lost == false then
		button_spawn(gwidth/2-237,gheight/2+79,"yes",yes_button_img)
		button_spawn(gwidth/2+79,gheight/2+79,"no",no_button_img)
		b_spawned_lost = true
	end
elseif gamestate == "localscores" then
	if b_spawned_scores == false then
		button_spawn(12,630,"back",back_button_img)
		b_spawned_scores = true
	end
elseif gamestate == "controlstate" then
	if b_spawned_controls == false then
		button_spawn(12,630,"backcontrol",back_button_img)
		b_spawned_controls = true
	end
elseif paused == true then
	if b_spawned_pause == false then
		button_spawn(gwidth/2+79,gheight/2+79,"return",back_button_img)
		button_spawn(gwidth/2-237,gheight/2+79,"resume",resume_button_img)
		b_spawned_pause = true
	end
elseif gamestate == "aboutstate" then
	if b_spawned_about == false then
		button_spawn(12,630,"back",back_button_img)
		b_spawned_about = true
		end
	end
end

function button_draw()
	for i,v in ipairs (button) do
		love.graphics.setColor(255,255,255)
		if gamestate == "menu" then
			if v.id == "play" then
					love.graphics.draw(play_button_img,v.x,v.y)
			elseif v.id == "settings" then
					love.graphics.draw(settings_button_img,v.x,v.y)
			elseif v.id == "quit" then
				love.graphics.draw(quit_button_img,v.x,v.y)
			elseif v.id == "scorelist" then
				love.graphics.draw(score_button_img,v.x,v.y)
			elseif v.id == "about" then
				love.graphics.draw(about_button_img,v.x,v.y)
			end
		end
		if gamestate == "settingstate" then
			if v.id == "v_right" then
				love.graphics.draw(rightarrow_button_img,v.x,v.y)
			elseif v.id == "v_left" then
				love.graphics.draw(leftarrow_button_img,v.x,v.y)
			elseif v.id == "s_left" then
				love.graphics.draw(leftarrow_button_img,v.x,v.y)
			elseif v.id == "s_right" then
				love.graphics.draw(rightarrow_button_img,v.x,v.y)
			elseif v.id == "km_left" then
				love.graphics.draw(leftarrow_button_img,v.x,v.y)
			elseif v.id == "km_right" then
				love.graphics.draw(rightarrow_button_img,v.x,v.y)
			elseif v.id == "back" then
				love.graphics.draw(back_button_img,v.x,v.y)
			elseif v.id == "controls" then
				love.graphics.draw(controls_button_img,v.x,v.y)
			end
		end
		if gamestate == "lost" then
			if v.id == "yes" then
				love.graphics.draw(yes_button_img,v.x,v.y)
			elseif v.id == "no" then
				love.graphics.draw(no_button_img,v.x,v.y)
			end
		end
		if paused == true then
			if v.id == "resume" then
				love.graphics.draw(resume_button_img,v.x,v.y)
			elseif v.id == "return" then
				love.graphics.draw(back_button_img,v.x,v.y)
			end
		end
		if gamestate == "localscores" then
			if v.id == "back" then
				love.graphics.draw(back_button_img,v.x,v.y)
			end
		end
		if gamestate == "controlstate" then
			if v.id == "backcontrol" then
				love.graphics.draw(back_button_img,v.x,v.y)
			end
		end
		if gamestate == "aboutstate" then
			if v.id == "back" then
				love.graphics.draw(back_button_img,v.x,v.y)
			end
		end
	end
end

function button_click(x,y)
	for i,v in ipairs (button) do
		if love.mouse.getX() > v.x and
		love.mouse.getX() < v.x + (v.image):getWidth() and
		love.mouse.getY() > v.y and
		love.mouse.getY() < v.y + (v.image):getHeight() then
			if gamestate == "menu" then
				if v.id == "play" then
					love.audio.play(button_press_snd)
					load()
					gamestate = "playing"
					game_Restart()
				elseif v.id == "settings" then
					love.audio.play(button_press_snd)
					gamestate = "settingstate"
				elseif v.id == "quit" then
					love.event.quit()
				elseif v.id == "scorelist" then
					love.audio.play(button_press_snd)
					gamestate = "localscores"
					load()
				elseif v.id == "about" then
					love.audio.play(button_press_snd)
					gamestate = "aboutstate"
				end
			end
			if gamestate == "settingstate" then
				if v.id == "v_right" then
					v_volume = v_volume + v_change_amount
					love.audio.setVolume(v_volume)
					love.audio.play(button_press_snd)
				elseif v.id == "v_left" then
					v_volume = v_volume - v_change_amount
					love.audio.setVolume(v_volume)
					love.audio.play(button_press_snd)
				elseif v.id == "s_right" then
					love.audio.play(button_press_snd)
					if gamemode == 1 then
						gamemode = 0
					elseif gamemode == 0 then
						gamemode = 1
					end
					spritecheck()
				elseif v.id == "s_left" then
					love.audio.play(button_press_snd)
					if gamemode == 1 then
						gamemode = 0
					elseif gamemode == 0 then
						gamemode = 1
					end
					spritecheck()
				elseif v.id == "km_left" then
					love.audio.play(button_press_snd)
					if keyboard == 1 then
						keyboard = 0
						mouseHeld = true
					elseif keyboard == 0 then
						keyboard = 1
						mouseHeld = false
					end
				elseif v.id == "km_right" then
					love.audio.play(button_press_snd)
					if keyboard == 1 then
						keyboard = 0
						mouseHeld = true
					elseif keyboard == 0 then
						keyboard = 1
						mouseHeld = false
					end
				elseif v.id == "back" then
					love.audio.play(button_press_snd)
					gamestate = "menu"
				elseif v.id == "controls" then
					love.audio.play(button_press_snd)
					gamestate = "controlstate"
				end
			end
			if gamestate == "lost" then
				if v.id == "yes" then
					love.audio.play(button_press_snd)
					gamestate = "playing"
					game_Restart()
				elseif v.id == "no" then
					love.audio.play(button_press_snd)
					gamestate = "menu"
				end
			end
			if paused == true then
				if v.id == "resume" then
					love.audio.play(button_press_snd)
					paused = false
				elseif v.id == "return" then
					love.audio.play(button_press_snd)
					if keyboard == 1 then
						endgameSave()
					end
					paused = false
					gamestate = "menu"
					game_Restart()
				end
			end
			if gamestate == "localscores" then
				if v.id == "back" then
					love.audio.play(button_press_snd)
					gamestate = "menu"
				end
			end
			if gamestate == "controlstate" then
				if v.id == "backcontrol" then
					love.audio.play(button_press_snd)
					gamestate = "settingstate"
				end
			end
			if gamestate == "aboutstate" then
				if v.id == "back" then
					love.audio.play(button_press_snd)
					gamestate = "menu"
				end
			end
		end
	end
end

function mouseGrabber()
	if mouseHeld == true then
		love.mouse.setGrabbed(true)
	end
	if mouseHeld == false then
		love.mouse.setGrabbed(false)
	end
end